#! /usr/bin/perl -w

use strict;

my $word = shift;

if ( not defined $word ) {
    die "Arguments:  word  <filename>";
}

my $file = shift;
if ( not defined $file ) {
    $file = "nxcgtx.rdb";
}

my $p = 1;

my $pattern = "\^" . $word . "\$";

$pattern =~ s/cq/(jq|sx|jx|zq|sq|cq)/g;
$pattern =~ s/jq([^|])/(jq|sq|jx|sx|zq|cq)$1/g;
$pattern =~ s/sq([^|])/(jq|sq|sx|jx|zq|cq)$1/g;
$pattern =~ s/zq([^|])/(jq|sx|jx|zq|sq|cq)$1/g;
$pattern =~ s/sx([^|])/(jq|sx|jx|sq|zq|cq)$1/g;
$pattern =~ s/jx([^|])/(jq|sx|jx|zq|sq|cq)$1/g;
$pattern =~ s/zx([^|])/(z|c|zx|zq)$1/g;

$pattern =~ s/s([^xq|])/(s|z|sx|sq)$1/g;
$pattern =~ s/z([^xq|])/(s|z|zx|jx|dx|zq)$1/g;

$pattern =~ s/cx([^|])/(cx|sx|gx|jx|cq|sq)$1/g;
$pattern =~ s/gx([^|])/(gx|sx|cx|jx|cq|sq)$1/g;

$pattern =~ s/px([^|])/(f|fx|px|vx|v|b|p|w)$1/g;
$pattern =~ s/fx([^|])/(f|fx|vx|px|v|b|p|w)$1/g;
$pattern =~ s/vx([^|])/(f|fx|px|v|b|p|w)$1/g;

$pattern =~ s/v([^x|])/(f|v|fx|vx|b|m|dx|w)$1/g;
$pattern =~ s/f([^x|])/(f|v|fx|vx|p|tx|w)$1/g;
$pattern =~ s/p([^qx|])/(p|b|f|fx|m|w)$1/g;
$pattern =~ s/b([^x|])/(b|p|v|vx|m|w)$1/g;

$pattern =~ s/kx?([^xq|])/(k|kx|g|hx)$1/g;
$pattern =~ s/g([^xq|])/(g|kx|k|hq)$1/g;
$pattern =~ s/h([^xq|])/h[qx]*$1/g;
$pattern =~ s/hq([^xq|])/(hx|g|kx|hq)$1/g;
$pattern =~ s/hx([^\)xq|])/(k|h|hx|hq)$1/g;

$pattern =~ s/t([^xq|\)])/(t|d|tx)$1/g;
$pattern =~ s/d([^xq|\)])/(d|t|dx)$1/g;

$pattern =~ s/tx([^|\)])/(t|dx|tx)$1/g;
$pattern =~ s/dx([^|\)])/(d|dx|tx)$1/g;

$pattern =~ s/nq/(nq|m|n|nx|)/g;

$pattern =~ s/nx$/(m|n|nx|nq)/g;
$pattern =~ s/nx([^|])/(m|n|nx|nq)/g;

$pattern =~ s/m$/(vx|m|v|n|nx|w)/g;
$pattern =~ s/m([^|qn])/(vx|v|m|n|w)$1/g;

$pattern =~ s/n$/(m|n|nx|nq)/g;
$pattern =~ s/n([^qx|\]])/(m|n|nx)$1/g;

$pattern =~ s/[lr]([^xq|])/[lr]$1/g;
$pattern =~ s/[lr]$/[lr]/g;

$pattern =~ s/[jw]([^\)xq|])/[jw]$1/g;
$pattern =~ s/[jw]$/[jw]/g;

### vowels

$pattern =~ s/o[qx]*/o[qx]*/g;
$pattern =~ s/ax/ax*/g;
$pattern =~ s/a([^x])/(a|ax)$1/g;
$pattern =~ s/a$/(a|ax)/g;
$pattern =~ s/iq/(iq|i|e)/g;
$pattern =~ s/[uy]/[uy]/g;

print "searching using $pattern\n";

open IN, $file or die "can't open $file";

my @found;
while ( <IN> ) {
    my $line = $_;
    my @fields = split /\t/;
    if ( $fields[1] =~ /[rkmpnsxz]/ ) {
	if ( $fields[0] =~ $pattern ) {
	    push @found, $fields[0] . "\t" .  $fields[2] . "\n";
	}
    }
}

print sort @found;
