#!/usr/bin/perl 
 
eval '$'.$1.'$2;' while $ARGV[0] =~ /^([A-Za-z_0-9]+=)(.*)/ && shift; 
			# process any FOO=bar switches 
 

$, = ' ';		# set output field separator 
$\ = "\n";		# set output record separator 

# TODO: read in whole file, split each line, stash array reg in array
# or hash then sort keys and process each wanted line postprocess each
# line by stripping out '__' (so obviate need for wrapper shell script
# that sorts input and strips __ from output, also make it possible to
# detect words in glosses and morphemes in compound words that need to
# be linked

use strict;
use gzb_ascii_unicode;

sub make_hyperlink( $ );

my $entries;
my $nxiqn_daxm_zqa;
my $bjax_niqm;
my $anchor;
my $cqur;
my $derived;
my $dxujm;
my $gun;
my $jum;
my $nxwiqm;
my $pxyr;
my $roots;

my $Word;
my $RootType;
my $gloss;
my $Fld4;
my $Fld5;
my $etym;


print<<HEADER;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"
       "http://www.w3.org/TR/REC-html40/strict.dtd">
<html>
<head>
<title>
gj&#226;-zym-byn (gzb): Lexicon / Glosaro / nxiqn-cu gjax-txy-za
</title>
<meta name = "keywords" "content = "lexicon glosaro word list root derived constructed language conlang">
<meta name = "generator" content="gen-nxcgtx_htm.pl">
<style> BODY { font-family: "Lucida Sans Unicode", sans-serif } </style>
</head>
<body>
<h1>
<a target="_top" href="gzb.htm">gj&#226;-zym-byn</a> (gzb)<br>Lexicon / Glosaro / nxiqn-cu gjax-txy-za
</h1>

<DL>
HEADER


 
 
# include all entry types except (x) erroneous forms, and (z) reserved for future use  
 
while (<>) { 
    chomp;	# strip record separator 
    ( $Word, $RootType, $gloss, $Fld4, $Fld5, $etym ) = split("\t", $_, 9999); 
    if ($RootType =~ /[bfmpksndr]/) { 
	$entries++; 
 
	if ($RootType =~ /[mpksnr]/) { 
	    $roots++; 
	} 
	if ($RootType eq 'r') { 
	    $gun++; 
	} 
	if ($RootType eq 'n') { 
	    $nxwiqm++; 
	} 
	if ($RootType eq 'm') { 
	    $jum++; 
	} 
	if ($RootType eq 'p') { 
	    $cqur++; 
	} 
	if ($RootType eq 'k') { 
	    $dxujm++; 
	} 
	if ($RootType eq 's') { 
	    $pxyr++; 
	} 
 
	if ($RootType =~ /[bf]/) { 
	    $bjax_niqm++; 
	} 
	if ($RootType eq 'd') { 
	    $derived++; 
	} 
	if ($etym ne '') { 
	    $nxiqn_daxm_zqa++; 
	} 
 
	$anchor = $Word; 
#	$anchor =~ s/x/__x/g; 
#	$anchor =~ s/q/__q/g; 
	my $s = "'";
	$anchor =~ s/$s//g; 
 	$anchor =~ s/ /___/g; 

	###TODO
=pod
        if ( $Word =~ /-/ ) {
	    # split on morphemes, link each morpheme to another entry
	    my @morphemes = split( /([- ])/, $Word );
	    my $linkedword = "";
	    my $j = 0;
	    for ( $j = 0; $j < scalar(@morphemes); $j++ ) {
		if ( .......word is found in lexicon array .... ) ...........
		make_hyperlink( $morphemes[$j] );
	    }
        }
=cut

	print "<DT id=\"" . $anchor . "\">" . gzb_ascii_unicode_convert( $Word ); 
 
	print '<DD>' . gzb_ascii_unicode_convert( $gloss );  
 
	if ($etym ne '') { 
	    $etym =~ s/i\^/\\$&#xEE;/g; 
	    $etym =~ s/a:/\\$&#xE4;/g; 
	    $etym =~ s/o:/\\$&#xF6;/g; 
	    print '( &lt; ' . $etym . ')'; 
	} 
    } 
} # end for each line in lexicon 
 
print "</DL>\n"; 
 
print '<hr>'; 
 
print '<table cellspacing=5>'; 
print '<tr><td> &nbsp;  Total content roots: <td> ' . $gun; 
print '<tr><td> &nbsp;  Total pronouns: <td> ' . $nxwiqm; 
print '<tr><td> &nbsp;  Total modifier particles: <td> ' . $jum; 
print '<tr><td> &nbsp;  Total conjunctions: <td> ' . $dxujm; 
print '<tr><td> &nbsp;  Total suffixes: <td> ' . $pxyr; 
print '<tr><td> &nbsp;  Spacetime postpositions: <br> &nbsp; (only a few are listed in the lexicon) <td> ' . $cqur;
print '<tr><td> Total root morphemes: <td> ' . $roots; 
print '<tr><td> Total derived words: <td> ' . $derived; 
print '<tr><td> Total acronyms and foreign names: <td> ' . $bjax_niqm; 
print '<tr><td> Total <em>a posteriori</em> roots (words with etymologies) <td> ' . $nxiqn_daxm_zqa; 
print '<tr><td> Total entries: <td> ' . $entries; 
print '</table>'; 
 
print '<ul>'; 
print "<li><a target=\"_top\"  href=\"n__xcgt__x.rdb\">Tab-delimited text version of lexicon (from which this file is automatically generated)</a>  "; 
print  "<li><a target=\"_top\"   href=\"gzb.htm\">Main {gj&#226;-zym-byn} index </a>  "; 
print "<li><a target=\"_top\"   href=\"phonology.htm\">Phonology </a> "; 
print "<li><a target=\"_top\"   href=\"grammar.htm\">Grammar</a> "; 
print "<li><a target=\"_top\"   href=\"semantic.htm\">Semantics</a> "; 
print "<li><a target=\"_top\"   href=\"../conlang.htm\"> My conlang page</a> "; 
print "<li><a target=\"_top\"   href=\"../index.htm\"> My home page</a>"; 
print "</ul>\n"; 
 
print '<p>Last modified / lasta gxisdatigo <br>'; 
print scalar( localtime() ); 
print "\n</body></html>\n"; 

### END



sub make_hyperlink( $ ) {
    my $linkword = shift;
    my $anchortext = $linkword;
    $anchortext =~ s/'//g;
    $anchortext =~ s/x/__x/g;
    $anchortext =~ s/q/__q/g;
    my $link = qq(<a href="#$anchortext">$linkword</a>);
    return $link;
}
