#! /usr/bin/awk -f

# TO DO: nested UL matching different level H1, H2, H3 headers

BEGIN {
  header_line_num = -999;
  lastlevel = 0;
  FS = "[<> =\t\"]+";
}

/<[Hh][1-4] +id/ {
  header_line_num = NR;
  anchor = $4;
  level = $2;
  gsub( /[Hh]/, "", level );
  if ( lastlevel < level ) {
    for ( i = 0; i < ( level - lastlevel ); i++ ) {
      print "<ul>";
    }
  } else if (  lastlevel > level ) {
    for ( i = 0; i < ( lastlevel - level ); i++ ) {
      print "</ul>";
    }
  }
  
#  print "$2 = [" $2 "], $3 = [" $3 "], $4 = [" $4 "], " > "/dev/stderr"
  lastlevel = level;
}

1 + header_line_num == NR {
  print "<li><a href = \"" FILENAME "#" anchor "\">" $0 "</a>";
}

END { 
  print "<!-- level " level " -->"
  while ( level-- ) {
   print "</ul>";
  }
}
