#! /bin/bash

echo Error-checking and correcting link_examples.tab...
./sort-samples-links.pl

## this makes sense with a dual-processor machine, wasteful on single-processor.
## TODO: figure out how to check if current machine has 2+ processors
#echo Generating categorical lexicon as background task
#./gen-nxcgtx_categ_htm.sh &
echo Generating categorical lexicon...
./gen-nxcgtx_categ_htm.sh

# avoid conflict, let the first script finish slurping its input file before
# the next one starts
#sleep 3
echo Generating alphabetical lexicon...
./gen-nxcgtx_htm.sh
#sleep 5

####TODO add call to Anki import file exporter here...

if [ corpus/samples.txt -nt samples_f.html ]; then
    echo Generating sample sentences frameset
    ./gen-glossed-doc-frameset.pl corpus/samples.txt -t 'Miscellaneous sample sentences and short texts'
else
    echo samples.txt not updated recently so not generating new samples frameset
fi

if [ corpus/fru-kxiqn-tla-sqam.txt -nt fru-kxiqn-tla-sqam_f.html ]; then
    echo Generating fru-kxiqn-tla-sqam frameset
    ./gen-glossed-doc-frameset.pl corpus/fru-kxiqn-tla-sqam.txt -t 'fru kxiqn-tla-sqam  (an unfinished fairy tale)'
else
    echo fru-kxiqn-tla-sqam.txt not updated recently so not generating new frameset for it
fi

echo Updating scripts and rdb zip files
./zipper.sh

date +%s
