
use strict;


my @header;
my @fields;
my %lexicon_rows;


sub sortcateg {
    my @f_a = split( "\t",  $lexicon_rows{ $a } );
    my @f_b = split( "\t",  $lexicon_rows{ $b } );
    my $catcmp = $f_a[3] cmp $f_b[3];
    if ( 0 == $catcmp ) {
	return $a cmp $b;
    } else {
	return $catcmp;
    }
}


open LEXICON, "nxcgtx.rdb";
open CQUR, "cqur.rdb";


my $i = "000";
while ( <LEXICON> ) {
    if ( $. <= 2 ) {
	$_ =~ s/[\r\n]+//g;
	push @header, $_;
    } else {
	@fields = split "\t";
	if ( @fields[0] eq "~~~" ) {
	    $lexicon_rows{ @fields[0] . $i++ } = $_;
	} else {
	    $lexicon_rows{ @fields[0] } = $_;
	}
    }
}

while ( <CQUR> ) {
    @fields = split "\t";
    if ( ! grep { $_ eq $fields[0] } keys %lexicon_rows ) {
	$lexicon_rows{ @fields[0] } = $_;
    }
}

foreach ( @header ) {
    print $_ . "\n";
}

foreach ( sort sortcateg keys %lexicon_rows ) {
    $lexicon_rows{ $_ } =~ s/[\r\n]+//g;
    print $lexicon_rows{ $_ } . "\n";
}


### END

