
use strict;

my $arg;
my $nxcgtx = undef;

while ( $arg = shift ) {
    if ( $arg !~ /^-/ ) {
	$nxcgtx = shift;
	next;
    }
}

if ( not defined $nxcgtx ) {
    $nxcgtx = "nxcgtx.rdb";
}

my @fields;
my @words;
my $vowels;

open NXCGTX,  $nxcgtx   or die "can't open $nxcgtx for reading";

while ( <NXCGTX> ) {
    chomp;
    @fields = split /\t/;
    if ( $fields[1] =~ /[dr]/ && $fields[0] !~ /rq/ ) {
	my $t = $fields[0];
	$vowels = $t =~ s/[aeiouy][qx]*/_/g;
	if ( $vowels == 2 ) {
	     #print "found 2-syll word: " . $fields[0] . "\n";
	     push @words, $fields[0];
	 }
    }
}


foreach ( @words ) {
    # now how to split up and recombine the words?
    my @parts = split /([aeiouy][qx]*[a-z]*)/;
    if ( $#parts != 3 ) {
	print join ":", @parts; 	###DEBUG
	print "\n";
    } else {
	my @g = split /(['-])/, $parts[2];
	my $sep = @g[1];
	if ( $g[2] eq $parts[0] ) { 		# a trivial match like {keq'kul} or {peq'pax}
		next;
	}
	my $spoonerism = $g[2] . $parts[1] . $sep . $parts[0] . $parts[3];
	#print $_ . "\t\t" . $spoonerism . "\n";
	my $matches = scalar( grep m/^$spoonerism$/, @words );
	if ( $matches >= 1 ) {
		print "FOUND MATCH: " . "\t\t" . $_ . "\t\t" . $spoonerism . "\n";
	} else {
		print $spoonerism . "\n";
	}
    }
}
