#! /usr/bin/perl -w

use strict;

my @rows;

my $i = 0;
my $j = 0;

while ( <> )
{
    if ( ! /\[TOTAL/ ) {
	my @fields = split /\t/;
	my $word = $fields[ 2 ];

	# preprocessing for gzb; comment out the next few lines if you
	# are adapting this to another conlang

	# these morphemes already have a glyph of their own;
	# words and phrases containing them need to have their weight
	# adjusted downward

	$word =~ s/-zox/Z/g;
	$word =~ s/-van/V/g;
	$word =~ s/mwiql/M/g;
	$word =~ s/kxiqm-kyw/K/g;

	$word =~ s/[-xq'\s]//g;


	my $len = length( $word );

 #  This is supposed to show how much space will be saved by replacing
 # a word with a logogram... so reduce by 1.  no help substituting a
 # {i, o, rq, pq, kq} etc. that are one letter already.

	my $weighted = $fields[ 1 ] * ($len - 1);
	$rows[ $i++ ] = sprintf( "%5d\t%3d\t%s", $weighted, $len, $_);
    }
}

@rows = sort { $b cmp $a } @rows;

    for ( my $j = 0; $j < $i; $j++ ) {
	print $rows[ $j ];
    }
